#define INCL_REXXSAA
#define INCL_RXSHV
#include <rexxsaa.h>

#include <time.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

static void RexxFuncComplete( int ok, PRXSTRING ret )
{
  if( ok )
  {
    strcpy( ret->strptr, "OK" );
    ret->strlength = 2;
  }
  else
  {
    strcpy( ret->strptr, "FAIL" );
    ret->strlength = 4;
  }
}

static int RexxCheckArgs( ULONG numarg, PRXSTRING args,
                          PRXSTRING ret, char *routine, int how )
{
  int i;

  if( numarg!=how )
  {
    fprintf( stderr, "%s: Need %d arguments\n", routine, how );
    RexxFuncComplete( 0, ret );
    return 1;
  }

  for( i=0; i<numarg; i++ )
    if( args[i].strptr==NULL )
    {
      fprintf( stderr, "%s: Illegal argument #%d\n", routine, i );
      RexxFuncComplete( 0, ret );
      return 1;
    }

  return 0;
}

RexxFunctionHandler UnixTime;

ULONG UnixTime( unsigned char *_1, ULONG numarg, PRXSTRING args,
               unsigned char *_2, PRXSTRING ret )
{
  ULONG tm;
  char *e;

  if( RexxCheckArgs( numarg, args, ret, "UnixTime", 1 ) )
    return 1;

  tm = strtoul( args[0].strptr, &e, 10 );

  if( *e )
  {
    fprintf( stderr, "UnixTime: Illegal time: %s\n", args[0].strptr );
    RexxFuncComplete( 0, ret );
    return 1;
  }

  tzset();

  e = ctime( (PLONG)&tm );

  if( e==NULL )
  {
    fprintf( stderr, "UnixTime: VAC++ bug for time: %s\n", args[0].strptr );
    strcpy( ret->strptr, "FAIL" );
  }
  else
  {
    e[ strlen(e)-1 ] = 0 ;
    strcpy( ret->strptr, e );
  }
  
  ret->strlength = strlen( ret->strptr );

  return 0;
}
